
	include	"hexlib.h"


	xdef	_main
        xdef    _ti92plus                                        


	xdef	_nostub
;*****************************************************
_ti92plus:
_nostub:

LCD_MEM equ     $4C00

DEREF   macro   ; Dn,An
        lsl.w   #2,\1
;        move.l  doorsos::Heap,\2
        move.l  $7592,\2
        move.l  0(\2,\1.w),\2
        endm

ROM_CALL macro
        move.l ($C8),a4
        add.l #\1*4,a4
        move.l (a4),a4
        jsr (a4)
        endm

_main:
	movem.l 	d0-d7/a0-a6,-(a7)
        move.l          $78,OldAutoInt6
	
	move.l          #TSR_End-TSR_Start,d0

        move.l  	d0,-(a7)
        ROM_CALL 	$92    			;jsr     tios::HeapAllocHigh
        addq.l  	#4,a7

        move.w  	d0,Handle
;        move.w  	d0,-(a7)
;        ROM_CALL 	$9A    			;jsr     _ROM_CALL_09A ; lock
;        addq.l  	#2,a7

        move.w  	Handle,d1
        DEREF   	d1,a0

	move.l		a0,a1
	lea		TSR_Start(pc),a2
	move.l          #TSR_End-TSR_Start,d0
	subq.w		#1,d0
LoopCopyTsr:
	move.b		(a2)+,(a1)+
	dbf		d0,LoopCopyTsr

	move.l		a0,$40078
	movem.l 	(a7)+,d0-d7/a0-a6
        rts






TSR_Start:

New_Auto6:
 
        movem.l d0-d7/a0-a6,-(a7)

NA6_Loop: 
   ;     btst    #1,($60001a)
   ;     bne     NA6_End

   ;     move.w  #$feff,($600018)
   ;     btst    #6,($60001b)
   ;     bne     NA6_Loop



     




        clr.w           doorsos::kb_globals+$1C

        ROM_CALL 	$18E			:doorsos::FontGetSys
;	clr.w		d7
	lea.l		Font(PC),a0
	move.w		d0,(a0)

        move.w          #0,-(a7)
        ROM_CALL 	$18F			;doorsos::FontSetSys
        lea             2(a7),a7

        move.w          #4,-(a7)
        pea             Truc(pc)
        move.w          #55,-(a7)        	; y
        move.w          #2,-(a7)       		; x 
        ROM_CALL 	$1A9			;doorsos::DrawStrXY
        lea             10(a7),a7
	

        move.w          #4,-(a7)
        pea             Keys(pc)
        move.w          #72,-(a7)        	; y
        move.w          #16,-(a7)       		; x 
        ROM_CALL 	$1A9			;doorsos::DrawStrXY
        lea             10(a7),a7

	
MainLoop:

	lea.l		KeyCode(PC),a0
	move.w		#11,d1
KeyScanLoop:
	move.w		(a0)+,d0
	cmp.w		d0,d2
	beq		KeyChange
	dbra		d1,KeyScanLoop

NoKey:
	clr.L		d0
	clr.l		d1
	move.l		#2,d6
	lea.l		RegAdress(PC),a0
	moveq		#2,d5
DispRegLoop:
	move.l		d6,d2
	move.l		(a0)+,a1
      	move.w          (a1),d0             
	move.l		#8,d1
	move.l		#3,d4
	bsr		hexlib::put_bin
	clr.L		d0
	add.l		#8,d6
	dbra		d5,DispRegLoop
	bra		End

KeyChange:
	move.w		#12,d2
	addq		#1,d1
	sub.w		d1,d2		
	divu.w		#4,d2
	move.w		d2,d1
	swap		d2
	lea.l		KeyMask(PC),a0
	lea.l		RegAdress(PC),a1
	lsl.w		#2,d1
	lsl.w		#1,d2
	add.w		d1,a1
	move.l		(a1),a3
	add.w		d2,a0
	move.w		(a0),d2

	move.w		(a3),d1
	eor.w		d2,d1
	move.w		d1,(a3)
	
	bra		MainLoop

End:
	lea.l		Font(PC),a0
        move.w          (a0),-(a7)
        ROM_CALL	$18F			;doorsos::FontSetSys
        addq.w          #2,a7


NA6_End: 
        movem.l (a7)+,d0-d7/a0-a6
        move.l  OldAutoInt6(pc),-(a7)

        rts
        clr.b   ($60001a)          ;dbloque ON pour int 6
        rte
End_Auto6:
	rts



put_char:
	movem.l	d1-d2/a0-a1,-(a7)

	lsl.l	#3,d0
	lea	numbers(pc),a0		; a0 -> numbers + 8*char
	add.l	d0,a0

	move.l	#LCD_MEM,a1		; a1 -> LCD + 240*row + column
	lsl.l	#4,d1
	move.l	d1,d0
	lsl.l	#4,d0
	sub.l	d1,d0
	add.l	d2,d0
	add.l	d0,a1

	move.l	#30,d1			; 30 bytes per pixel row
	move.w	#7,d2			; 8 bytes per character
put_char_loop:
	move.b	(a0)+,(a1)
	add.l	d1,a1
	dbf.w	d2,put_char_loop

	movem.l	(a7)+,d1-d2/a0-a1
	rts

;*****************************************************


put_bin:
	movem.l	d3-d5,-(a7)

put_bin_loop:
	move.l	d0,d5			; save number
	lsr.l	d4,d0
	and.l	#1,d0
	bsr	put_char
	move.l	d5,d0			; restore number
	addq.l	#1,d2			; increment column
	dbf.w	d4,put_bin_loop

	movem.l	(a7)+,d3-d5
	rts

;*****************************************************


put_hex:
	movem.l	d3-d5,-(a7)

put_hex_loop:
	move.l	d0,d5			; save number
	move.l	d4,d3
	lsl.l	#2,d3			; d3 = 4*loopcount (# bits to shift)
	lsr.l	d3,d0
	and.l	#$0000000F,d0
	bsr	put_char
	move.l	d5,d0			; restore number
	addq.l	#1,d2			; increment column
	dbf.w	d4,put_hex_loop

	movem.l	(a7)+,d3-d5
	rts

;*****************************************************
; NUMBER CHARACTER DATA
;*****************************************************
numbers:
	dc.b %01111100	* 0
	dc.b %11000110
	dc.b %11000110
	dc.b %11010110
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %00011000	* 1
	dc.b %00111000
	dc.b %01111000
	dc.b %00011000
	dc.b %00011000
	dc.b %00011000
	dc.b %01111110
	dc.b %00000000

	dc.b %01111100	* 2
	dc.b %11000110
	dc.b %00000110
	dc.b %00111100
	dc.b %01100000
	dc.b %11000000
	dc.b %11111110
	dc.b %00000000

	dc.b %11111110	* 3
	dc.b %00000110
	dc.b %00001100
	dc.b %00111100
	dc.b %00000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %00011100	* 4
	dc.b %00111100
	dc.b %01101100
	dc.b %11001100
	dc.b %11111110
	dc.b %00001100
	dc.b %00001100
	dc.b %00000000

	dc.b %11111110	* 5
	dc.b %11000000
	dc.b %11000000
	dc.b %11111100
	dc.b %00000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %00111100	* 6
	dc.b %01100110
	dc.b %11000000
	dc.b %11111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %11111110	* 7
	dc.b %00000110
	dc.b %00001100
	dc.b %00011000
	dc.b %00110000
	dc.b %01100000
	dc.b %11000000
	dc.b %00000000

	dc.b %01111100	* 8
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %01111100	* 9
	dc.b %11000110
	dc.b %11000110
	dc.b %01111110
	dc.b %00000110
	dc.b %00001100
	dc.b %01111000
	dc.b %00000000

	dc.b %00111000	* A
	dc.b %01101100
	dc.b %11000110
	dc.b %11111110
	dc.b %11000110
	dc.b %11000110
	dc.b %11000110
	dc.b %00000000

	dc.b %11111100	* B
	dc.b %11000110
	dc.b %11000110
	dc.b %11111100
	dc.b %11000110
	dc.b %11000110
	dc.b %11111100
	dc.b %00000000

	dc.b %00111100	* C
	dc.b %01100110
	dc.b %11000000
	dc.b %11000000
	dc.b %11000000
	dc.b %01100110
	dc.b %00111100
	dc.b %00000000

	dc.b %11111000	* D
	dc.b %11001100
	dc.b %11000110
	dc.b %11000110
	dc.b %11000110
	dc.b %11001100
	dc.b %11111000
	dc.b %00000000

	dc.b %11111110	* E
	dc.b %11000000
	dc.b %11000000
	dc.b %11111000
	dc.b %11000000
	dc.b %11000000
	dc.b %11111110
	dc.b %00000000

	dc.b %11111110	* F
	dc.b %11000000
	dc.b %11000000
	dc.b %11111000
	dc.b %11000000
	dc.b %11000000
	dc.b %11000000
	dc.b %00000000

;*****************************************************
; miscellaneous program data
;*****************************************************

	EVEN
RegAdress	dc.l	$C0001A,$C0001C,$C0001E
OldAutoInt6     dc.l    0

Handle		dc.w	0
Font		dc.w	0

	EVEN
KeyCode		dc.w	'q','w','e','r','t','y','u','i','7','8','9','*'
KeyMask		dc.w	%1000,%0100,%0010,%0001

Truc	    dc.b    "30s IRQ BUSY HOLD     t1 t0 INT MASK      TEST 24 STP RST",0 
Keys	    dc.b    "Q W  E  R                  T  Y  U   I                  7  8  9  *",0 


        EVEN

TSR_End:

;*****************************************************

	end
